Index: issm/trunk/test/NightlyRun/IdToName.m
===================================================================
--- issm/trunk/test/NightlyRun/IdToName.m	(revision 10442)
+++ issm/trunk/test/NightlyRun/IdToName.m	(revision 10443)
@@ -208,4 +208,6 @@
 	case 451, name='SquareSheetShelfGroundingLine3dAgressiceSerial';
 	case 452, name='SquareSheetShelfGroundingLine3dAgressiceParallel';
+	case 453, name='SquareSheetShelfGroundingLine3dSoftSerial';
+	case 454, name='SquareSheetShelfGroundingLine3dSoftParallel';
 	case 501, name='PigDiagM2dSerial';
 	case 502, name='PigDiagM2dParallel';
Index: issm/trunk/test/NightlyRun/test453.m
===================================================================
--- issm/trunk/test/NightlyRun/test453.m	(revision 10443)
+++ issm/trunk/test/NightlyRun/test453.m	(revision 10443)
@@ -0,0 +1,41 @@
+md=setmesh(model,'../Exp/Square.exp',150000);
+md=setmask(md,'../Exp/SquareShelf.exp','');
+md=parameterize(md,'../Par/SquareSheetShelf.par');
+md.initialization.vx(:)=0;
+md.initialization.vy(:)=0;
+md.initialization.vel(:)=0;
+md.geometry.bed=-700-abs(md.mesh.y-500000)/1000;
+md.geometry.bathymetry=-700-abs(md.mesh.y-500000)/1000;
+md.geometry.thickness(:)=1300;
+md.geometry.surface=md.geometry.bed+md.geometry.thickness;
+md=extrude(md,3,1);
+md=setflowequation(md,'macayeal','all');
+
+md.surfaceforcings.mass_balance(:)=-150;
+md.transient.isdiagnostic=0;
+md.transient.isgroundingline=1;
+md.groundingline.migration='SoftMigration';
+md.cluster=none;
+md=solve(md,TransientSolutionEnum);
+
+%Fields and tolerances to track changes
+field_names     ={'Bed1','Surface1','Thickness1','Floatingice1',...
+	'Bed2','Surface2','Thickness2','Floatingice2',...
+	'Bed3','Surface3','Thickness3','Floatingice3'};
+field_tolerances={1e-13,1e-13,1e-13,1e-13,...
+	1e-13,1e-13,1e-13,1e-13,...
+	1e-13,1e-13,1e-13,1e-13};
+field_values={...
+	PatchToVec(md.results.TransientSolution(1).Bed),...
+	PatchToVec(md.results.TransientSolution(1).Surface),...
+	PatchToVec(md.results.TransientSolution(1).Thickness),...
+	PatchToVec(md.results.TransientSolution(1).MaskElementonfloatingice),...
+	PatchToVec(md.results.TransientSolution(2).Bed),...
+	PatchToVec(md.results.TransientSolution(2).Surface),...
+	PatchToVec(md.results.TransientSolution(2).Thickness),...
+	PatchToVec(md.results.TransientSolution(2).MaskElementonfloatingice),...
+	PatchToVec(md.results.TransientSolution(3).Bed),...
+	PatchToVec(md.results.TransientSolution(3).Surface),...
+	PatchToVec(md.results.TransientSolution(3).Thickness),...
+	PatchToVec(md.results.TransientSolution(3).MaskElementonfloatingice),...
+	};
Index: issm/trunk/test/NightlyRun/test454.m
===================================================================
--- issm/trunk/test/NightlyRun/test454.m	(revision 10443)
+++ issm/trunk/test/NightlyRun/test454.m	(revision 10443)
@@ -0,0 +1,41 @@
+md=setmesh(model,'../Exp/Square.exp',150000);
+md=setmask(md,'../Exp/SquareShelf.exp','');
+md=parameterize(md,'../Par/SquareSheetShelf.par');
+md.initialization.vx(:)=0;
+md.initialization.vy(:)=0;
+md.initialization.vel(:)=0;
+md.geometry.bed=-700-abs(md.mesh.y-500000)/1000;
+md.geometry.bathymetry=-700-abs(md.mesh.y-500000)/1000;
+md.geometry.thickness(:)=1300;
+md.geometry.surface=md.geometry.bed+md.geometry.thickness;
+md=setflowequation(md,'macayeal','all');
+md=extrude(md,3,1);
+
+md.surfaceforcings.mass_balance(:)=-150;
+md.transient.isdiagnostic=0;
+md.transient.isgroundingline=1;
+md.groundingline.migration='SoftMigration';
+md.cluster=generic('name',oshostname(),'np',3);
+md=solve(md,TransientSolutionEnum);
+
+%Fields and tolerances to track changes
+field_names     ={'Bed1','Surface1','Thickness1','Floatingice1',...
+	'Bed2','Surface2','Thickness2','Floatingice2',...
+	'Bed3','Surface3','Thickness3','Floatingice3'};
+field_tolerances={1e-13,1e-13,1e-13,1e-13,...
+	1e-13,1e-13,1e-13,1e-13,...
+	1e-13,1e-13,1e-13,1e-13};
+field_values={...
+	PatchToVec(md.results.TransientSolution(1).Bed),...
+	PatchToVec(md.results.TransientSolution(1).Surface),...
+	PatchToVec(md.results.TransientSolution(1).Thickness),...
+	PatchToVec(md.results.TransientSolution(1).MaskElementonfloatingice),...
+	PatchToVec(md.results.TransientSolution(2).Bed),...
+	PatchToVec(md.results.TransientSolution(2).Surface),...
+	PatchToVec(md.results.TransientSolution(2).Thickness),...
+	PatchToVec(md.results.TransientSolution(2).MaskElementonfloatingice),...
+	PatchToVec(md.results.TransientSolution(3).Bed),...
+	PatchToVec(md.results.TransientSolution(3).Surface),...
+	PatchToVec(md.results.TransientSolution(3).Thickness),...
+	PatchToVec(md.results.TransientSolution(3).MaskElementonfloatingice),...
+	};