Index: issm/trunk-jpl/test/NightlyRun/test259.m
===================================================================
--- issm/trunk-jpl/test/NightlyRun/test259.m	(revision 10937)
+++ issm/trunk-jpl/test/NightlyRun/test259.m	(revision 10976)
@@ -31,39 +31,39 @@
 
 field_values={...
-	PatchToVec(md.results.TransientSolution(1).Vx),...
-	PatchToVec(md.results.TransientSolution(1).Vy),...
-	PatchToVec(md.results.TransientSolution(1).Vz),...
-	PatchToVec(md.results.TransientSolution(1).Vel),...
-	PatchToVec(md.results.TransientSolution(1).Pressure),...
-	PatchToVec(md.results.TransientSolution(1).Bed),...
-	PatchToVec(md.results.TransientSolution(1).Surface),...
-	PatchToVec(md.results.TransientSolution(1).Thickness),...
-	PatchToVec(md.results.TransientSolution(1).SurfaceforcingsMassBalance),...
-	PatchToVec(md.results.TransientSolution(2).Vx),...
-	PatchToVec(md.results.TransientSolution(2).Vy),...
-	PatchToVec(md.results.TransientSolution(2).Vz),...
-	PatchToVec(md.results.TransientSolution(2).Vel),...
-	PatchToVec(md.results.TransientSolution(2).Pressure),...
-	PatchToVec(md.results.TransientSolution(2).Bed),...
-	PatchToVec(md.results.TransientSolution(2).Surface),...
-	PatchToVec(md.results.TransientSolution(2).Thickness),...
-	PatchToVec(md.results.TransientSolution(2).SurfaceforcingsMassBalance),...
-	PatchToVec(md.results.TransientSolution(3).Vx),...
-	PatchToVec(md.results.TransientSolution(3).Vy),...
-	PatchToVec(md.results.TransientSolution(3).Vz),...
-	PatchToVec(md.results.TransientSolution(3).Vel),...
-	PatchToVec(md.results.TransientSolution(3).Pressure),...
-	PatchToVec(md.results.TransientSolution(3).Bed),...
-	PatchToVec(md.results.TransientSolution(3).Surface),...
-	PatchToVec(md.results.TransientSolution(3).Thickness),...
-	PatchToVec(md.results.TransientSolution(3).SurfaceforcingsMassBalance),...
-	PatchToVec(md.results.TransientSolution(4).Vx),...
-	PatchToVec(md.results.TransientSolution(4).Vy),...
-	PatchToVec(md.results.TransientSolution(4).Vz),...
-	PatchToVec(md.results.TransientSolution(4).Vel),...
-	PatchToVec(md.results.TransientSolution(4).Pressure),...
-	PatchToVec(md.results.TransientSolution(4).Bed),...
-	PatchToVec(md.results.TransientSolution(4).Surface),...
-	PatchToVec(md.results.TransientSolution(4).Thickness),...
-	PatchToVec(md.results.TransientSolution(4).SurfaceforcingsMassBalance),...
+	(md.results.TransientSolution(1).Vx),...
+	(md.results.TransientSolution(1).Vy),...
+	(md.results.TransientSolution(1).Vz),...
+	(md.results.TransientSolution(1).Vel),...
+	(md.results.TransientSolution(1).Pressure),...
+	(md.results.TransientSolution(1).Bed),...
+	(md.results.TransientSolution(1).Surface),...
+	(md.results.TransientSolution(1).Thickness),...
+	(md.results.TransientSolution(1).SurfaceforcingsMassBalance),...
+	(md.results.TransientSolution(2).Vx),...
+	(md.results.TransientSolution(2).Vy),...
+	(md.results.TransientSolution(2).Vz),...
+	(md.results.TransientSolution(2).Vel),...
+	(md.results.TransientSolution(2).Pressure),...
+	(md.results.TransientSolution(2).Bed),...
+	(md.results.TransientSolution(2).Surface),...
+	(md.results.TransientSolution(2).Thickness),...
+	(md.results.TransientSolution(2).SurfaceforcingsMassBalance),...
+	(md.results.TransientSolution(3).Vx),...
+	(md.results.TransientSolution(3).Vy),...
+	(md.results.TransientSolution(3).Vz),...
+	(md.results.TransientSolution(3).Vel),...
+	(md.results.TransientSolution(3).Pressure),...
+	(md.results.TransientSolution(3).Bed),...
+	(md.results.TransientSolution(3).Surface),...
+	(md.results.TransientSolution(3).Thickness),...
+	(md.results.TransientSolution(3).SurfaceforcingsMassBalance),...
+	(md.results.TransientSolution(4).Vx),...
+	(md.results.TransientSolution(4).Vy),...
+	(md.results.TransientSolution(4).Vz),...
+	(md.results.TransientSolution(4).Vel),...
+	(md.results.TransientSolution(4).Pressure),...
+	(md.results.TransientSolution(4).Bed),...
+	(md.results.TransientSolution(4).Surface),...
+	(md.results.TransientSolution(4).Thickness),...
+	(md.results.TransientSolution(4).SurfaceforcingsMassBalance),...
 	};