Index: issm/trunk-jpl/cron/configs/linux64_larour
===================================================================
--- issm/trunk-jpl/cron/configs/linux64_larour	(revision 11121)
+++ issm/trunk-jpl/cron/configs/linux64_larour	(revision 11122)
@@ -53,5 +53,5 @@
 
 #List of external pakages to be installed
-EXTERNALPACKAGES="autoconf automake matlab mpich2 petsc metis triangle dakota chaco"
+EXTERNALPACKAGES="autoconf automake libtool matlab mpich2 petsc metis triangle dakota chaco"
 
 #---------------------#
Index: issm/trunk-jpl/cron/configs/linux64_morlighem_daily
===================================================================
--- issm/trunk-jpl/cron/configs/linux64_morlighem_daily	(revision 11121)
+++ issm/trunk-jpl/cron/configs/linux64_morlighem_daily	(revision 11122)
@@ -53,5 +53,5 @@
 
 #List of external pakages to be installed
-EXTERNALPACKAGES="automake autoconf matlab mpich2 petsc metis triangle dakota chaco"
+EXTERNALPACKAGES="automake autoconf libtool matlab mpich2 petsc metis triangle dakota chaco"
 
 #---------------------#
Index: issm/trunk-jpl/cron/configs/linux64_morlighem_nightly
===================================================================
--- issm/trunk-jpl/cron/configs/linux64_morlighem_nightly	(revision 11121)
+++ issm/trunk-jpl/cron/configs/linux64_morlighem_nightly	(revision 11122)
@@ -53,5 +53,5 @@
 
 #List of external pakages to be installed
-EXTERNALPACKAGES="autoconf automake matlab mpich2 petsc metis triangle dakota chaco"
+EXTERNALPACKAGES="autoconf automake libtool matlab mpich2 petsc metis triangle dakota chaco"
 
 #---------------------#
Index: issm/trunk-jpl/cron/configs/linux64_morlighem_validation
===================================================================
--- issm/trunk-jpl/cron/configs/linux64_morlighem_validation	(revision 11121)
+++ issm/trunk-jpl/cron/configs/linux64_morlighem_validation	(revision 11122)
@@ -52,5 +52,5 @@
 
 #List of external pakages to be installed
-EXTERNALPACKAGES="autoconf automake matlab mpich2 petsc metis triangle dakota chaco yams"
+EXTERNALPACKAGES="autoconf automake libtool matlab mpich2 petsc metis triangle dakota chaco yams"
 
 #---------------------#
Index: issm/trunk-jpl/cron/configs/linux64_seroussi
===================================================================
--- issm/trunk-jpl/cron/configs/linux64_seroussi	(revision 11121)
+++ issm/trunk-jpl/cron/configs/linux64_seroussi	(revision 11122)
@@ -52,5 +52,5 @@
 
 #List of external pakages to be installed
-EXTERNALPACKAGES="autoconf automake matlab mpich2 petsc metis triangle dakota chaco"
+EXTERNALPACKAGES="autoconf automake libtool matlab mpich2 petsc metis triangle dakota chaco"
 
 #---------------------#
Index: issm/trunk-jpl/cron/configs/linux64_seroussi_daily
===================================================================
--- issm/trunk-jpl/cron/configs/linux64_seroussi_daily	(revision 11121)
+++ issm/trunk-jpl/cron/configs/linux64_seroussi_daily	(revision 11122)
@@ -53,5 +53,5 @@
 
 #List of external pakages to be installed
-EXTERNALPACKAGES="autoconf automake matlab mpich2 petsc metis triangle dakota chaco"
+EXTERNALPACKAGES="autoconf automake libtool matlab mpich2 petsc metis triangle dakota chaco"
 
 #---------------------#
Index: issm/trunk-jpl/cron/configs/linux64_seroussi_nightly
===================================================================
--- issm/trunk-jpl/cron/configs/linux64_seroussi_nightly	(revision 11121)
+++ issm/trunk-jpl/cron/configs/linux64_seroussi_nightly	(revision 11122)
@@ -53,5 +53,5 @@
 
 #List of external pakages to be installed
-EXTERNALPACKAGES="autoconf automake matlab mpich2 petsc metis triangle dakota chaco"
+EXTERNALPACKAGES="autoconf automake libtool matlab mpich2 petsc metis triangle dakota chaco"
 
 #---------------------#
Index: issm/trunk-jpl/cron/configs/linux64_seroussi_ucitrunk
===================================================================
--- issm/trunk-jpl/cron/configs/linux64_seroussi_ucitrunk	(revision 11121)
+++ issm/trunk-jpl/cron/configs/linux64_seroussi_ucitrunk	(revision 11122)
@@ -53,5 +53,5 @@
 
 #List of external pakages to be installed
-EXTERNALPACKAGES="autoconf automake matlab mpich2 petsc metis triangle dakota chaco"
+EXTERNALPACKAGES="autoconf automake libtool matlab mpich2 petsc metis triangle dakota chaco"
 
 #---------------------#
Index: issm/trunk-jpl/cron/configs/linux64_seroussi_validation
===================================================================
--- issm/trunk-jpl/cron/configs/linux64_seroussi_validation	(revision 11121)
+++ issm/trunk-jpl/cron/configs/linux64_seroussi_validation	(revision 11122)
@@ -52,5 +52,5 @@
 
 #List of external pakages to be installed
-EXTERNALPACKAGES="autoconf automake matlab mpich2 petsc metis triangle dakota chaco yams"
+EXTERNALPACKAGES="autoconf automake libtool matlab mpich2 petsc metis triangle dakota chaco yams"
 
 #---------------------#
Index: issm/trunk-jpl/cron/configs/macosx32_seroussi
===================================================================
--- issm/trunk-jpl/cron/configs/macosx32_seroussi	(revision 11121)
+++ issm/trunk-jpl/cron/configs/macosx32_seroussi	(revision 11122)
@@ -52,5 +52,5 @@
 
 #List of external pakages to be installed
-EXTERNALPACKAGES="autoconf automake matlab mpich2 petsc metis triangle dakota chaco"
+EXTERNALPACKAGES="autoconf automake libtool matlab mpich2 petsc metis triangle dakota chaco"
 
 #---------------------#
Index: issm/trunk-jpl/cron/configs/macosx64_larour
===================================================================
--- issm/trunk-jpl/cron/configs/macosx64_larour	(revision 11121)
+++ issm/trunk-jpl/cron/configs/macosx64_larour	(revision 11122)
@@ -51,5 +51,5 @@
 
 #List of external pakages to be installed
-EXTERNALPACKAGES="autoconf automake matlab mpich2 petsc metis triangle"
+EXTERNALPACKAGES="autoconf automake libtool matlab mpich2 petsc metis triangle"
 
 #---------------------#
Index: issm/trunk-jpl/cron/configs/winxp32_larour
===================================================================
--- issm/trunk-jpl/cron/configs/winxp32_larour	(revision 11121)
+++ issm/trunk-jpl/cron/configs/winxp32_larour	(revision 11122)
@@ -52,5 +52,5 @@
 
 #List of external pakages to be installed
-EXTERNALPACKAGES="autoconf automake matlab mpich2 petsc metis triangle dakota chaco"
+EXTERNALPACKAGES="autoconf automake libtool matlab mpich2 petsc metis triangle dakota chaco"
 
 #---------------------#