Index: issm/trunk-jpl/src/c/include/types.h
===================================================================
--- issm/trunk-jpl/src/c/include/types.h	(revision 11196)
+++ issm/trunk-jpl/src/c/include/types.h	(revision 11197)
@@ -27,5 +27,5 @@
 
 /*here are our abstracted types: inspired on petsc */
-#if defined(ISSM_USE_64BIT_INDICES)
+#if ISSM_USE_64BIT_INDICES == 1
 typedef long long IssmInt;
 //#define MPIU_INT MPI_LONG_LONG_INT already define in petsc
Index: issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticVert/CreateConstraintsDiagnosticVert.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticVert/CreateConstraintsDiagnosticVert.cpp	(revision 11196)
+++ issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticVert/CreateConstraintsDiagnosticVert.cpp	(revision 11197)
@@ -68,6 +68,4 @@
 	iomodel->DeleteData(2,DiagnosticSpcvzEnum,FlowequationBorderstokesEnum);
 
-	cleanup_and_return:
-
 	/*Assign output pointer: */
 	*pconstraints=constraints;
Index: issm/trunk-jpl/src/c/modules/UpdateVertexPositionsx/UpdateVertexPositionsx.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/UpdateVertexPositionsx/UpdateVertexPositionsx.cpp	(revision 11196)
+++ issm/trunk-jpl/src/c/modules/UpdateVertexPositionsx/UpdateVertexPositionsx.cpp	(revision 11197)
@@ -30,3 +30,4 @@
 	xfree((void**)&thickness);
 	xfree((void**)&bed);
+	return 1;
 }
Index: issm/trunk-jpl/src/c/objects/Inputs/TransientInput.cpp
===================================================================
--- issm/trunk-jpl/src/c/objects/Inputs/TransientInput.cpp	(revision 11196)
+++ issm/trunk-jpl/src/c/objects/Inputs/TransientInput.cpp	(revision 11197)
@@ -352,6 +352,7 @@
 	infnorm=input->InfinityNorm();
 			   
-	delete input;
-
+	/*Clean-up and return*/
+	delete input;
+	return infnorm;
 }
 /*}}}*/
@@ -391,6 +392,6 @@
 	maxabs=input->MaxAbs();
 
-	delete input;
-
+	/*Clean-up and return*/
+	delete input;
 	return maxabs;
 
@@ -412,6 +413,6 @@
 	min=input->Min();
 
-	delete input;
-
+	/*Clean-up and return*/
+	delete input;
 	return min;
 
@@ -433,6 +434,6 @@
 	minabs=input->MinAbs();
 			   
-	delete input;
-
+	/*Clean-up and return*/
+	delete input;
 	return minabs;
 }
Index: issm/trunk-jpl/src/c/objects/Loads/Riftfront.cpp
===================================================================
--- issm/trunk-jpl/src/c/objects/Loads/Riftfront.cpp	(revision 11196)
+++ issm/trunk-jpl/src/c/objects/Loads/Riftfront.cpp	(revision 11197)
@@ -162,5 +162,5 @@
 	printf("   friction: %g\n",friction);
 	printf("   fraction: %g\n",fraction);
-	printf("   fractionincrement: %i\n",fractionincrement);
+	printf("   fractionincrement: %g\n",fractionincrement);
 	printf("   state: %i\n",state);
 	printf("   frozen: %s\n",frozen ? "true":"false");
@@ -771,4 +771,5 @@
 	/*assign output pointer: */
 	*punstable=unstable;
+	return 1;
 }
 /*}}}1*/
@@ -850,5 +851,5 @@
 	/*assign output pointer: */
 	*ppenetration=penetration;
-
+	return 1;
 }
 /*}}}1*/
@@ -889,5 +890,5 @@
 	/*assign output pointer: */
 	*ppenetration=penetration;
-
+	return 1;
 }
 /*}}}1*/
@@ -942,4 +943,5 @@
 	/*assign output pointer: */
 	*punstable=unstable;
+	return 1;
 }
 /*}}}1*/
@@ -1006,4 +1008,5 @@
 	/*assign output pointer: */
 	*punstable=unstable;
+	return 1;
 }
 /*}}}1*/
Index: issm/trunk-jpl/src/c/objects/Params/IntMatParam.cpp
===================================================================
--- issm/trunk-jpl/src/c/objects/Params/IntMatParam.cpp	(revision 11196)
+++ issm/trunk-jpl/src/c/objects/Params/IntMatParam.cpp	(revision 11197)
@@ -64,5 +64,5 @@
 	for(i=0;i<this->M;i++){
 		for(i=0;i<this->N;i++){
-			printf("%i %i %g\n",i,j,*(this->value+N*i+j));
+			printf("(%i,%i) %i\n",i,j,*(this->value+N*i+j));
 		}
 	}
Index: issm/trunk-jpl/src/c/objects/Params/IntVecParam.cpp
===================================================================
--- issm/trunk-jpl/src/c/objects/Params/IntVecParam.cpp	(revision 11196)
+++ issm/trunk-jpl/src/c/objects/Params/IntVecParam.cpp	(revision 11197)
@@ -78,5 +78,5 @@
 	printf("   vector size: %i\n",this->M);
 	for(i=0;i<this->M;i++){
-		printf("%i %g\n",i,this->values[i]);
+		printf("%i %i\n",i,this->values[i]);
 	}
 }
Index: issm/trunk-jpl/src/c/objects/Vertex.cpp
===================================================================
--- issm/trunk-jpl/src/c/objects/Vertex.cpp	(revision 11196)
+++ issm/trunk-jpl/src/c/objects/Vertex.cpp	(revision 11197)
@@ -71,5 +71,5 @@
 	printf("   z: %g\n",z);
 	printf("   sigma: %g\n",sigma);
-	printf("   connectivity: %g\n",connectivity);
+	printf("   connectivity: %i\n",connectivity);
 	printf("   dof: %i\n",dof);
 	printf("   clone: %i\n",clone);
Index: issm/trunk-jpl/src/c/shared/Elements/GetVerticesCoordinates.cpp
===================================================================
--- issm/trunk-jpl/src/c/shared/Elements/GetVerticesCoordinates.cpp	(revision 11196)
+++ issm/trunk-jpl/src/c/shared/Elements/GetVerticesCoordinates.cpp	(revision 11197)
@@ -5,5 +5,5 @@
 #include "./elements.h"
 
-int GetVerticesCoordinates(double* xyz,  Node** nodes, int numvertices){
+void GetVerticesCoordinates(double* xyz,  Node** nodes, int numvertices){
 
 	/*In debugging mode, check that nodes is not a NULL pointer*/
Index: issm/trunk-jpl/src/c/shared/Elements/elements.h
===================================================================
--- issm/trunk-jpl/src/c/shared/Elements/elements.h	(revision 11196)
+++ issm/trunk-jpl/src/c/shared/Elements/elements.h	(revision 11197)
@@ -13,5 +13,5 @@
 double Paterson(double temperature);
 double Arrhenius(double temperature,double depth,double n);
-int    GetVerticesCoordinates(double* xyz,  Node** nodes, int numvertices);
+void   GetVerticesCoordinates(double* xyz,  Node** nodes, int numvertices);
 int    GetNumberOfDofs( Node** nodes,int numnodes,int setenum,int approximation_enum);
 int*   GetLocalDofList( Node** nodes,int numnodes,int setenum,int approximation_enum);
Index: issm/trunk-jpl/src/c/solvers/solver_thermal_nonlinear.cpp
===================================================================
--- issm/trunk-jpl/src/c/solvers/solver_thermal_nonlinear.cpp	(revision 11196)
+++ issm/trunk-jpl/src/c/solvers/solver_thermal_nonlinear.cpp	(revision 11197)
@@ -30,5 +30,4 @@
 	int thermal_penalty_threshold;
 	int thermal_maxiter;
-	bool reset_penalties;
 
 	/*parameters:*/
@@ -49,6 +48,6 @@
 
 	_printf_(VerboseSolution(),"%s\n","starting direct shooting method");
-	InputUpdateFromConstantx( femmodel->elements,femmodel->nodes, femmodel->vertices, femmodel->loads, femmodel->materials, femmodel->parameters,reset_penalties,ResetPenaltiesEnum);
-	InputUpdateFromConstantx( femmodel->elements,femmodel->nodes, femmodel->vertices, femmodel->loads, femmodel->materials, femmodel->parameters,false,ConvergedEnum);
+	InputUpdateFromConstantx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,true,ResetPenaltiesEnum);
+	InputUpdateFromConstantx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,false,ConvergedEnum);
 	UpdateConstraintsx(femmodel->nodes,femmodel->constraints,femmodel->parameters);
 
@@ -62,5 +61,5 @@
 		MatFree(&Kff);VecFree(&pf);VecFree(&tg); VecFree(&df);
 		Mergesolutionfromftogx(&tg, tf,ys,femmodel->nodes,femmodel->parameters); VecFree(&ys);
-		InputUpdateFromSolutionx(femmodel->elements,femmodel->nodes, femmodel->vertices, femmodel->loads, femmodel->materials, femmodel->parameters,tg);
+		InputUpdateFromSolutionx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,tg);
 
 		ConstraintsStatex(&constraints_converged, &num_unstable_constraints, femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
Index: issm/trunk-jpl/src/c/toolkits/petsc/patches/MatPartition.cpp
===================================================================
--- issm/trunk-jpl/src/c/toolkits/petsc/patches/MatPartition.cpp	(revision 11196)
+++ issm/trunk-jpl/src/c/toolkits/petsc/patches/MatPartition.cpp	(revision 11197)
@@ -123,3 +123,4 @@
 	/*Assign output pointers:*/
 	*poutmatrix=outmatrix;
+	return 1;
 }