Index: issm/trunk-jpl/src/c/objects/KML/KML_File.cpp
===================================================================
--- issm/trunk-jpl/src/c/objects/KML/KML_File.cpp	(revision 11346)
+++ issm/trunk-jpl/src/c/objects/KML/KML_File.cpp	(revision 11383)
@@ -24,5 +24,5 @@
 KML_File::KML_File(){
 
-	kmlobj    =new DataSet;
+	;
 
 }
@@ -31,8 +31,5 @@
 KML_File::~KML_File(){
 
-	if (kmlobj) {
-		delete kmlobj;
-		kmlobj    =NULL;
-	}
+	;
 
 }
@@ -47,6 +44,4 @@
 	_printf_(flag,"KML_File:\n");
 	KML_Object::Echo();
-
-	_printf_(flag,"        kmlobj: (size=%d)\n" ,kmlobj->Size());
 
 	return;
@@ -66,24 +61,8 @@
 void  KML_File::DeepEcho(const char* indent){
 
-	int   i;
-	char  indent2[81];
 	bool  flag=true;
 
 	_printf_(flag,"%sKML_File:\n",indent);
 	KML_Object::DeepEcho(indent);
-
-/*  loop over the kml objects for the file  */
-
-	memcpy(indent2,indent,(strlen(indent)+1)*sizeof(char));
-	strcat(indent2,"  ");
-
-	if (kmlobj->Size())
-		for (i=0; i<kmlobj->Size(); i++) {
-			_printf_(flag,"%s        kmlobj: -------- begin [%d] --------\n" ,indent,i);
-			((KML_Object *)kmlobj->GetObjectByOffset(i))->DeepEcho(indent2);
-			_printf_(flag,"%s        kmlobj: --------  end  [%d] --------\n" ,indent,i);
-		}
-	else
-		_printf_(flag,"%s        kmlobj: [empty]\n"    ,indent);
 
 	return;
@@ -93,7 +72,4 @@
 void  KML_File::Write(FILE* filout,const char* indent){
 
-	int   i;
-	char  indent2[81];
-
 	fprintf(filout,"%s<kml",indent);
 	WriteAttrib(filout," ");
@@ -102,13 +78,4 @@
 
 	KML_Object::Write(filout,indent);
-
-/*  loop over the kml objects for the file  */
-
-	memcpy(indent2,indent,(strlen(indent)+1)*sizeof(char));
-
-	strcat(indent2,"  ");
-
-	for (i=0; i<kmlobj->Size(); i++)
-		((KML_Object *)kmlobj->GetObjectByOffset(i))->Write(filout,indent2);
 
 	fprintf(filout,"%s</kml>\n",indent);
@@ -144,106 +111,4 @@
 			_error_("KML_File::Read -- Unexpected field \"%s\".\n",kstri);
 
-		else if (!strncmp(kstri,"<Placemark",10)) {
-			kobj=(KML_Object*)new KML_Placemark();
-			kobj->Read(fid,kstri);
-			kmlobj    ->AddObject((Object*)kobj);
-		}
-
-		else if (!strncmp(kstri,"<Folder", 7)) {
-			kobj=(KML_Object*)new KML_Folder();
-			kobj->Read(fid,kstri);
-			kmlobj    ->AddObject((Object*)kobj);
-		}
-
-		else if (!strncmp(kstri,"<Document", 9)) {
-			kobj=(KML_Object*)new KML_Document();
-			kobj->Read(fid,kstri);
-			kmlobj    ->AddObject((Object*)kobj);
-		}
-
-		else if (!strncmp(kstri,"<GroundOverlay",14)) {
-			kobj=(KML_Object*)new KML_GroundOverlay();
-			kobj->Read(fid,kstri);
-			kmlobj    ->AddObject((Object*)kobj);
-		}
-
-		else if (!strncmp(kstri,"<LatLonBox",10)) {
-			kobj=(KML_Object*)new KML_LatLonBox();
-			kobj->Read(fid,kstri);
-			kmlobj    ->AddObject((Object*)kobj);
-		}
-
-		else if (!strncmp(kstri,"<Icon", 5)) {
-			kobj=(KML_Object*)new KML_Icon();
-			kobj->Read(fid,kstri);
-			kmlobj    ->AddObject((Object*)kobj);
-		}
-
-		else if (!strncmp(kstri,"<Point", 6)) {
-			kobj=(KML_Object*)new KML_Point();
-			kobj->Read(fid,kstri);
-			kmlobj    ->AddObject((Object*)kobj);
-		}
-
-		else if (!strncmp(kstri,"<LineString",11)) {
-			kobj=(KML_Object*)new KML_LineString();
-			kobj->Read(fid,kstri);
-			kmlobj    ->AddObject((Object*)kobj);
-		}
-
-		else if (!strncmp(kstri,"<LinearRing",11)) {
-			kobj=(KML_Object*)new KML_LinearRing();
-			kobj->Read(fid,kstri);
-			kmlobj    ->AddObject((Object*)kobj);
-		}
-
-		else if (!strncmp(kstri,"<Polygon", 8)) {
-			kobj=(KML_Object*)new KML_Polygon();
-			kobj->Read(fid,kstri);
-			kmlobj    ->AddObject((Object*)kobj);
-		}
-
-		else if (!strncmp(kstri,"<MultiGeometry",14)) {
-			kobj=(KML_Object*)new KML_MultiGeometry();
-			kobj->Read(fid,kstri);
-			kmlobj    ->AddObject((Object*)kobj);
-		}
-
-//		else if (!strncmp(kstri,"<IconStyle",10)) {
-//			kobj=(KML_Object*)new KML_IconStyle();
-//			kobj->Read(fid,kstri);
-//			kmlobj    ->AddObject((Object*)kobj);
-//		}
-
-//		else if (!strncmp(kstri,"<LabelStyle",11)) {
-//			kobj=(KML_Object*)new KML_LabelStyle();
-//			kobj->Read(fid,kstri);
-//			kmlobj    ->AddObject((Object*)kobj);
-//		}
-
-		else if (!strncmp(kstri,"<LineStyle",10)) {
-			kobj=(KML_Object*)new KML_LineStyle();
-			kobj->Read(fid,kstri);
-			kmlobj    ->AddObject((Object*)kobj);
-		}
-
-		else if (!strncmp(kstri,"<PolyStyle",10)) {
-			kobj=(KML_Object*)new KML_PolyStyle();
-			kobj->Read(fid,kstri);
-			kmlobj    ->AddObject((Object*)kobj);
-		}
-
-//		else if (!strncmp(kstri,"<BalloonStyle",13)) {
-//			kobj=(KML_Object*)new KML_BalloonStyle();
-//			kobj->Read(fid,kstri);
-//			kmlobj    ->AddObject((Object*)kobj);
-//		}
-
-//		else if (!strncmp(kstri,"<ListStyle",10)) {
-//			kobj=(KML_Object*)new KML_ListStyle();
-//			kobj->Read(fid,kstri);
-//			kmlobj    ->AddObject((Object*)kobj);
-//		}
-
 		else if (!strncmp(kstri,"<",1))
 			KML_Object::Read(fid,kstri);
Index: issm/trunk-jpl/src/c/objects/KML/KML_File.h
===================================================================
--- issm/trunk-jpl/src/c/objects/KML/KML_File.h	(revision 11346)
+++ issm/trunk-jpl/src/c/objects/KML/KML_File.h	(revision 11383)
@@ -19,6 +19,4 @@
 
 	public:
-
-		DataSet* kmlobj;
 
 		/*KML_File constructors, destructors {{{1*/
Index: issm/trunk-jpl/src/c/objects/KML/KML_Object.cpp
===================================================================
--- issm/trunk-jpl/src/c/objects/KML/KML_Object.cpp	(revision 11346)
+++ issm/trunk-jpl/src/c/objects/KML/KML_Object.cpp	(revision 11383)
@@ -26,5 +26,5 @@
 	attrib    =new DataSet;
 	commnt    =new DataSet;
-	unknwn    =new DataSet;
+	kmlobj    =new DataSet;
 
 }
@@ -41,7 +41,7 @@
 		commnt    =NULL;
 	}
-	if (unknwn) {
-		delete unknwn;
-		unknwn    =NULL;
+	if (kmlobj) {
+		delete kmlobj;
+		kmlobj    =NULL;
 	}
 
@@ -57,5 +57,5 @@
 	_printf_(flag,"        attrib: (size=%d)\n" ,attrib->Size());
 	_printf_(flag,"        commnt: (size=%d)\n" ,commnt->Size());
-	_printf_(flag,"        unknwn: (size=%d)\n" ,unknwn->Size());
+	_printf_(flag,"        kmlobj: (size=%d)\n" ,kmlobj->Size());
 
 	return;
@@ -102,12 +102,12 @@
 	strcat(indent2,"  ");
 
-	if (unknwn->Size())
-		for (i=0; i<unknwn->Size(); i++) {
-            _printf_(flag,"%s        unknwn: -------- begin [%d] --------\n" ,indent,i);
-			((KML_Unknown *)unknwn->GetObjectByOffset(i))->DeepEcho(indent2);
-            _printf_(flag,"%s        unknwn: --------  end  [%d] --------\n" ,indent,i);
+	if (kmlobj->Size())
+		for (i=0; i<kmlobj->Size(); i++) {
+            _printf_(flag,"%s        kmlobj: -------- begin [%d] --------\n" ,indent,i);
+			((KML_Unknown *)kmlobj->GetObjectByOffset(i))->DeepEcho(indent2);
+            _printf_(flag,"%s        kmlobj: --------  end  [%d] --------\n" ,indent,i);
 		}
 	else
-		_printf_(flag,"%s        unknwn: [empty]\n"    ,indent);
+		_printf_(flag,"%s        kmlobj: [empty]\n"    ,indent);
 
 	return;
@@ -128,7 +128,7 @@
 	strcat(indent2,"  ");
 
-	if (unknwn->Size())
-		for (i=0; i<unknwn->Size(); i++) {
-			((KML_Unknown *)unknwn->GetObjectByOffset(i))->Write(filout,indent2);
+	if (kmlobj->Size())
+		for (i=0; i<kmlobj->Size(); i++) {
+			((KML_Unknown *)kmlobj->GetObjectByOffset(i))->Write(filout,indent2);
 		}
 
@@ -153,5 +153,5 @@
 		kobj=(KML_Object*)new KML_Placemark();
 		kobj->Read(fid,kstr);
-		unknwn    ->AddObject((Object*)kobj);
+		kmlobj    ->AddObject((Object*)kobj);
 	}
 
@@ -159,5 +159,5 @@
 		kobj=(KML_Object*)new KML_Folder();
 		kobj->Read(fid,kstr);
-		unknwn    ->AddObject((Object*)kobj);
+		kmlobj    ->AddObject((Object*)kobj);
 	}
 
@@ -165,5 +165,5 @@
 		kobj=(KML_Object*)new KML_Document();
 		kobj->Read(fid,kstr);
-		unknwn    ->AddObject((Object*)kobj);
+		kmlobj    ->AddObject((Object*)kobj);
 	}
 
@@ -171,5 +171,5 @@
 		kobj=(KML_Object*)new KML_GroundOverlay();
 		kobj->Read(fid,kstr);
-		unknwn    ->AddObject((Object*)kobj);
+		kmlobj    ->AddObject((Object*)kobj);
 	}
 
@@ -177,5 +177,5 @@
 		kobj=(KML_Object*)new KML_LatLonBox();
 		kobj->Read(fid,kstr);
-		unknwn    ->AddObject((Object*)kobj);
+		kmlobj    ->AddObject((Object*)kobj);
 	}
 
@@ -183,5 +183,5 @@
 		kobj=(KML_Object*)new KML_Icon();
 		kobj->Read(fid,kstr);
-		unknwn    ->AddObject((Object*)kobj);
+		kmlobj    ->AddObject((Object*)kobj);
 	}
 
@@ -189,5 +189,5 @@
 		kobj=(KML_Object*)new KML_Point();
 		kobj->Read(fid,kstr);
-		unknwn    ->AddObject((Object*)kobj);
+		kmlobj    ->AddObject((Object*)kobj);
 	}
 
@@ -195,5 +195,5 @@
 		kobj=(KML_Object*)new KML_LineString();
 		kobj->Read(fid,kstr);
-		unknwn    ->AddObject((Object*)kobj);
+		kmlobj    ->AddObject((Object*)kobj);
 	}
 
@@ -201,5 +201,5 @@
 		kobj=(KML_Object*)new KML_LinearRing();
 		kobj->Read(fid,kstr);
-		unknwn    ->AddObject((Object*)kobj);
+		kmlobj    ->AddObject((Object*)kobj);
 	}
 
@@ -207,5 +207,5 @@
 		kobj=(KML_Object*)new KML_Polygon();
 		kobj->Read(fid,kstr);
-		unknwn    ->AddObject((Object*)kobj);
+		kmlobj    ->AddObject((Object*)kobj);
 	}
 
@@ -213,5 +213,5 @@
 		kobj=(KML_Object*)new KML_MultiGeometry();
 		kobj->Read(fid,kstr);
-		unknwn    ->AddObject((Object*)kobj);
+		kmlobj    ->AddObject((Object*)kobj);
 	}
 
@@ -219,5 +219,5 @@
 //		kobj=(KML_Object*)new KML_IconStyle();
 //		kobj->Read(fid,kstr);
-//		unknwn    ->AddObject((Object*)kobj);
+//		kmlobj    ->AddObject((Object*)kobj);
 //	}
 
@@ -225,5 +225,5 @@
 //		kobj=(KML_Object*)new KML_LabelStyle();
 //		kobj->Read(fid,kstr);
-//		unknwn    ->AddObject((Object*)kobj);
+//		kmlobj    ->AddObject((Object*)kobj);
 //	}
 
@@ -231,5 +231,5 @@
 		kobj=(KML_Object*)new KML_LineStyle();
 		kobj->Read(fid,kstr);
-		unknwn    ->AddObject((Object*)kobj);
+		kmlobj    ->AddObject((Object*)kobj);
 	}
 
@@ -237,5 +237,5 @@
 		kobj=(KML_Object*)new KML_PolyStyle();
 		kobj->Read(fid,kstr);
-		unknwn    ->AddObject((Object*)kobj);
+		kmlobj    ->AddObject((Object*)kobj);
 	}
 
@@ -243,5 +243,5 @@
 //		kobj=(KML_Object*)new KML_BalloonStyle();
 //		kobj->Read(fid,kstr);
-//		unknwn    ->AddObject((Object*)kobj);
+//		kmlobj    ->AddObject((Object*)kobj);
 //	}
 
@@ -249,5 +249,5 @@
 //		kobj=(KML_Object*)new KML_ListStyle();
 //		kobj->Read(fid,kstr);
-//		unknwn    ->AddObject((Object*)kobj);
+//		kmlobj    ->AddObject((Object*)kobj);
 //	}
 
@@ -258,5 +258,5 @@
 		kobj=(KML_Object*)new KML_Unknown();
 		kobj->Read(fid,kstr);
-		unknwn    ->AddObject((Object*)kobj);
+		kmlobj    ->AddObject((Object*)kobj);
 	}
 
Index: issm/trunk-jpl/src/c/objects/KML/KML_Object.h
===================================================================
--- issm/trunk-jpl/src/c/objects/KML/KML_Object.h	(revision 11346)
+++ issm/trunk-jpl/src/c/objects/KML/KML_Object.h	(revision 11383)
@@ -21,5 +21,5 @@
 		DataSet* attrib;
 		DataSet* commnt;
-		DataSet* unknwn;
+		DataSet* kmlobj;
 
 		/*KML_Object constructors, destructors {{{1*/